# Nuxeo Widgets, ZPT macros ready to reuse
#
# Copyright (C) 2002 Juan David Ibez Palomar <jdavid@nuxeo.com>
#               2002 Nuxeo (http://www.nuxeo.com)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

"""Widgets"""
__version__ = "$Revision: 1.1.1.1 $"




widgets = {}




######################################################################
# Patch TALES, add the "widgets" name
######################################################################

from Products.PageTemplates.PageTemplate import PageTemplate
from Products.PageTemplates.PageTemplateFile import PageTemplateFile
from Products.PageTemplates.ZopePageTemplate import ZopePageTemplate

# Save old versions of "pt_getContext"
PageTemplate.pt_getContext_old = PageTemplate.pt_getContext
PageTemplateFile.pt_getContext_old = PageTemplateFile.pt_getContext
ZopePageTemplate.pt_getContext_old = ZopePageTemplate.pt_getContext


def pt_getContext(self):
    """
    New "pt_getContext" method, adds the "widgets" name.
    """

    c = self.pt_getContext_old()
    c['widgets'] = widgets

    return c

PageTemplate.pt_getContext = pt_getContext
PageTemplateFile.pt_getContext = pt_getContext
ZopePageTemplate.pt_getContext = pt_getContext




######################################################################
# Security, declare this module public
######################################################################

from AccessControl import ModuleSecurityInfo
ModuleSecurityInfo('Products').declarePublic('NuxWidgets')




######################################################################
# Register the widgets
######################################################################

# Calendar
from Calendar import calendar
widgets['calendar'] = calendar.macros['calendar']

# Timetable
from Timetable import timetable
widgets['timetable'] = timetable.macros['timetable']
